package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PapRiwayatPsikososialService;
import com.jasamedika.medifirst2000.util.DateUtil;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.PapRiwayatPsikososialVO;
import com.jasamedika.medifirst2000.vo.PapSkriningNyeriVO;

/**
 * Controller class for Pengakjian Awal Gawat Darurat Business
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/riwayat-psikososial")
@JsonIgnoreProperties(ignoreUnknown = true) 
public class PapRiwayatPsikososialController extends LocaleController<PapRiwayatPsikososialVO> implements
		IBaseRestController<PapRiwayatPsikososialVO> {
	
	private static final Logger LOGGER = LoggerFactory.getLogger(PapRiwayatPsikososialController.class);

	@Autowired
	private PapRiwayatPsikososialService papRiwayatPsikososialService;

	@RequestMapping(value = "/save-riwayat-psikososial", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> save(@Valid @RequestBody PapRiwayatPsikososialVO vo,HttpServletRequest request) {
		try {
			Map<String,Object> result = papRiwayatPsikososialService.addRiwayatPsikososial(vo);

			if (null != result){
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
				result.put("message", "Berhasil");
			}else{
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
				result.put("message", "Gagal");
			}
			SaveLog("Riwayat Psikososial", "Pemeriksaan",request);
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add Pasien", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add Pasien", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}

	@RequestMapping(value = "/edit-riwayat-psikososial", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> edit(@Valid @RequestBody PapRiwayatPsikososialVO vo,HttpServletRequest request) {
		try {
			Map<String,Object> result = papRiwayatPsikososialService.updateRiwayatPsikososial(vo);

			if (null != result){
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
				result.put("message", "Berhasil");
			}else{
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
				result.put("message", "Gagal");
			}
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add Pasien", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add Pasien", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}

	@RequestMapping(value = "/find-by-noCm-and-tglInput/{noCm}/{tglInput}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findByNoCm(@PathVariable("noCm") String noCm,@PathVariable("tglInput") String tglInput,HttpServletRequest request) {
		Map<String,Object> result = papRiwayatPsikososialService.findByNoCmAndTglInput(noCm, DateUtil.toDate(tglInput));
		Boolean dataFound=new Boolean((boolean) result.get("dataFound"));
		if(dataFound){
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
		}else{
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
		}

		return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
	}

	@RequestMapping(value = "/find-registrasi-pelayanan-pasien/{noCm}/{tglRegistrasi}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findRegistrasiPelayanaPasien(@PathVariable("noCm") String noCm,@PathVariable("tglRegistrasi") String tglRegistrasi,HttpServletRequest request) {
		Map<String,Object> result = papRiwayatPsikososialService.findRegistrasiPelayananPasienByNoCmAndTglRegistrasi(noCm,(short) 0, DateUtil.toDate(tglRegistrasi));
		Boolean dataFound=new Boolean((boolean) result.get("dataFound"));
		if(dataFound){
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
		}else{
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
		}

		return RestUtil.getJsonResponse(result, HttpStatus.OK);
	}

	@RequestMapping(value = "/find-pasien-by-noCm/{noCm}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findPasien(@PathVariable("noCm") String noCm,HttpServletRequest request) {
		Map<String,Object> result = papRiwayatPsikososialService.findPasienByNoCm(noCm);
		Boolean dataFound=new Boolean((boolean) result.get("dataFound"));
		if(dataFound){
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
		}else{
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
		}

		return RestUtil.getJsonResponse(result, HttpStatus.OK);
	}

	@Override
	public ResponseEntity<Collection<PapRiwayatPsikososialVO>> getAllVOWithQueryString(HttpServletRequest request,
			Integer page, Integer limit, String sort, String dir) {
		return null;
	}

	@Override
	public ResponseEntity<PapRiwayatPsikososialVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(PapRiwayatPsikososialVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(PapRiwayatPsikososialVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<PapRiwayatPsikososialVO>> getAllVO() {
		return null;
	}

	
}
